<!DOCTYPE html>
<html>
<head>
    <title>Grain - Alignement</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <style>
        body {
            background-color : #FFF;
            margin-top       : 20px;
        }

        #grain-alignement-form {
            margin     : auto;
            margin-top : 50px;
        }
    </style>
</head>
<body>
<!-- debut entete -->
<script src="jquery-1.9.1.js"></script>
<script src="alignement.js"></script>
<script src="jcanvas.min.js"></script>
<link rel="stylesheet" type="text/css" href="alignement.css"/>
<!-- fin entete -->
<!-- Debut du grain -->
<div id="grain-alignement">
    <div id="grain-alignement-etapes">
        <div class="grain-alignement-titre">
            Etapes
            <div class="grain-alignement-menu">
                <a href="javascript:alignement.afficherInstruction()" title="Afficher instructions">
                    <img src="alignement/aide.png" width="20" height="20" border="0"/>
                </a>
            </div>
        </div>
        <div class="grain-alignement-contenu" id="grain-alignement-listeEtapes">
          <ol>
            <li id="etape1"><a href="javascript:alignement.changerEtape(1)">Tracer un chemin</a></li>
            <li id="etape2"><a href="javascript:alignement.changerEtape(2)">Chercher un chemin optimal</a></li>
            <li id="etape3"><a href="javascript:alignement.changerEtape(3)">Algorithme - phase 1</a></li>
            <li id="etape4"><a href="javascript:alignement.changerEtape(4)">Retrouver les alignements optimaux</a></li>
            <li id="etape5"><a href="javascript:alignement.changerEtape(5)">Algorithme - phase 2</a></li>
          </ol>
        </div>
    </div>
    <div id="grain-alignement-alignements">
        <div class="grain-alignement-titre">
            Alignement courant
            <div class="grain-alignement-menu">
                <a href="javascript:alignement.afficherMessage(1)" title="Aide - Alignement courant">
                    <img src="alignement/aide.png" width="20" height="20" border="0"/>
                </a>
            </div>
        </div>
        <div class="grain-alignement-contenu" id="grain-alignement-listeAlignements">

        </div>
    </div>
    <div id="grain-alignement-matrice">
        <div class="grain-alignement-titre">
            Matrice - Coûts
        </div>
        <table class="grain-alignement-contenu"></table>
    </div>
    <div id="grain-alignement-chemins">
        <div class="grain-alignement-titre">
            Chemins
            <div class="grain-alignement-menu">
                <span id="grain-alignement-chemins-menu"></span>
                <a href="javascript:alignement.afficherInstruction()" title="Afficher instructions">
                    <img src="alignement/aide.png" width="20" height="20" border="0"/>
                </a>
            </div>
        </div>
        <div class="grain-alignement-contenu">
            <canvas width="515" height="380" id="grain-alignement-canvas"></canvas>
        </div>
    </div>
    <div id="grain-alignement-optimal">
        <div class="grain-alignement-titre">
            Coût optimal
            <div class="grain-alignement-menu">
                <a href="javascript:alignement.afficherMessage(2)" title="Aide - Coût optimal">
                    <img src="alignement/aide.png" width="20" height="20" border="0"/>
                </a>
            </div>
        </div>
        <div class="grain-alignement-contenu">

        </div>
    </div>
    <div id="grain-alignement-messages">
        <div class="grain-alignement-titre">
            Messages - <span id="grain-alignement-messagesTitre"></span>
        </div>
        <div class="grain-alignement-contenu" id="grain-alignement-messagesContenu">

        </div>
    </div>
</div>
<!-- Initialisation -->
<script>
    $(function () {

        function getURLParameter(name) {
            return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search) || [, ""])[1].replace(/\+/g, '%20')) || null;
        }

        var listeCouts = [4];
        listeCouts[0] = {AA: 0, AT: 1, AG: 1, AC: 1, TA: 1, TT: 0, TG: 1, TC: 1, GA: 1, GT: 1, GG: 0, GC: 1, CA: 1, CT: 1, CG: 1, CC: 0};
        listeCouts[1] = {AA: 0, AT: 1, AG: 0.7, AC: 1, TA: 1, TT: 0, TG: 1, TC: 0.7, GA: 0.7, GT: 1, GG: 0, GC: 1, CA: 1, CT: 0.7, CG: 1, CC: 0};

        /*
         * Initialisation
         */

        //Parametres
        /** Matrice coût */
        alignement.couts = (getURLParameter('matrice') !== null) ? listeCouts[getURLParameter('matrice')] : listeCouts[0];
        /** Coût d'un gap */
        alignement.coutGap = getURLParameter('coutGap') !== null ? Math.round(getURLParameter('coutGap') * 10) / 10 : 1;
        /** Sequence 1 */
        alignement.x = ( getURLParameter('seq1') !== null) ? getURLParameter('seq1').toUpperCase() : ["A", "G", "T", "A", "T", "C", "T"];
        /** Sequence 2 */
        alignement.y = ( getURLParameter('seq2') !== null) ? getURLParameter('seq2').toUpperCase() : ["A", "G", "A", "T", "G", "C"];
        /** Lettres */
        alignement.lettres = ["A", "T", "G", "C"];
        //Initialisation
        alignement.init();
        //chargement de l'étape
        initial_step = (getURLParameter('etape') !== null) ? getURLParameter('etape') : 1;
        alignement.changerEtape(parseInt(initial_step));
        for (step = 1 ; step <= initial_step ; step = step + 1) {
            $("#etape" + step).show();
        }
    });
</script>
<!-- Fin du grain -->
<!-- Début lancer -->
<form method="get" id="grain-alignement-form">
    <label>Première séquence : <input type="text" name="seq1"/></label>
    <label>Deuxième séquence : <input type="text" name="seq2"/></label>
    <label>Matrice :
        <select name="matrice">
            <optgroup label="Acides nucléiques" type="0">
                <option value="0">Unité</option>
                <option value="1">Transition/Transversion</option>
            </optgroup>
        </select>
    </label>
    <label>Coût d'un gap : <input type="text" name="coutGap" value="1"/></label>
    <label><input type="submit" value="Lancer"/></label><br/><br/>
</form>
<script>
    $("#grain-alignement-form select[name='type']").change(function () {
        var type = $("#grain-alignement-form select[name='type']").val();
        $("#grain-alignement-form select[name='matrice'] optgroup[type='" + (1 - type) + "']").attr('disabled', 'disabled');
        $("#grain-alignement-form select[name='matrice'] optgroup[type='" + type + "']").removeAttr('disabled');
        $("#grain-alignement-form select[name='matrice']").val(2 * type)
        $('#grain-alignement-form input[name="seq1"]').val("")
        $('#grain-alignement-form input[name="seq2"]').val("")

    })
    $('#grain-alignement-form input[name="seq1"]').keypress(function (event) {
        var type = $("#grain-alignement-form select[name='type']").val();
        var regex = (type == 1) ? new RegExp("^[ARNDCQEGHILKMFPSTWYV]+$") : new RegExp("^[AGTC]+$");
        var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
        key = key.toUpperCase();
        if (!regex.test(key)) {
            event.preventDefault();
            return false;
        }
    });
    $('#grain-alignement-form input[name="seq2"]').keypress(function (event) {
        var type = $("#grain-alignement-form select[name='type']").val();
        var regex = (type == 1) ? new RegExp("^[ARNDCQEGHILKMFPSTWYV]+$") : new RegExp("^[AGTC]+$");
        var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
        key = key.toUpperCase();
        if (!regex.test(key)) {
            event.preventDefault();
            return false;
        }
    });
</script>
<!-- Fin lanceur -->
</body>
</html>
